Index: GraphicsMagick-1.2.5/coders/png.c
===================================================================
--- GraphicsMagick-1.2.5.orig/coders/png.c	2018-01-19 20:08:30.737576639 +0100
+++ GraphicsMagick-1.2.5/coders/png.c	2018-01-19 20:29:20.474317244 +0100
@@ -1968,49 +2053,71 @@ static Image *ReadOnePNGImage(MngInfo *m
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
           "    Reading PNG tRNS chunk.");
 
-      bit_mask = (1 << ping_info->bit_depth) - 1;
+      bit_mask = (1U << ping_file_depth) - 1;
 
       /*
         Image has a transparent background.
       */
+
       transparent_color.red=
-        (Quantum)(ping_info->trans_values.red & bit_mask);
+        (unsigned long)(ping_trans_color->red & bit_mask);
       transparent_color.green=
-        (Quantum) (ping_info->trans_values.green & bit_mask);
+        (unsigned long) (ping_trans_color->green & bit_mask);
       transparent_color.blue=
-        (Quantum) (ping_info->trans_values.blue & bit_mask);
+        (unsigned long) (ping_trans_color->blue & bit_mask);
       transparent_color.opacity=
-        (Quantum) (ping_info->trans_values.gray & bit_mask);
-      if (ping_info->color_type == PNG_COLOR_TYPE_GRAY)
+        (unsigned long) (ping_trans_color->gray & bit_mask);
+
+      if (ping_colortype == PNG_COLOR_TYPE_GRAY)
         {
+#if (QuantumDepth == 8)
+          if (ping_file_depth < QuantumDepth)
+#endif
+            transparent_color.opacity=(unsigned long) (
+                ping_trans_color->gray *
+                (65535L/((1UL << ping_file_depth)-1)));
+
+#if (QuantumDepth == 8)
+          else
+            transparent_color.opacity=(unsigned long) (
+                (ping_trans_color->gray * 65535L)/
+                ((1UL << ping_file_depth)-1));
+#endif
+          if (logging != MagickFalse)
+            {
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                   "    Raw tRNS graylevel is %d.",ping_trans_color->gray);
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                   "    scaled graylevel is %d.",
+                   (int) transparent_color.opacity);
+            }
           transparent_color.red=transparent_color.opacity;
           transparent_color.green=transparent_color.opacity;
           transparent_color.blue=transparent_color.opacity;
         }
     }
 #if defined(PNG_READ_sBIT_SUPPORTED)
-  if (mng_info->have_global_sbit)
-    {
-      int
-        not_valid;
-      not_valid=!ping_info->valid;
-      if (not_valid & PNG_INFO_sBIT)
+  if (!png_get_valid(ping, ping_info, PNG_INFO_sBIT))
+    if (mng_info->have_global_sbit)
         png_set_sBIT(ping,ping_info,&mng_info->global_sbit);
-    }
 #endif
   num_passes=png_set_interlace_handling(ping);
+
   png_read_update_info(ping,ping_info);
+
+  ping_rowbytes=(png_uint_32) png_get_rowbytes(ping,ping_info);
+
   /*
     Initialize image structure.
   */
   mng_info->image_box.left=0;
-  mng_info->image_box.right=(long) ping_info->width;
+  mng_info->image_box.right=(long) ping_width;
   mng_info->image_box.top=0;
-  mng_info->image_box.bottom=(long) ping_info->height;
+  mng_info->image_box.bottom=(long) ping_height;
   if (mng_info->mng_type == 0)
     {
-      mng_info->mng_width=ping_info->width;
-      mng_info->mng_height=ping_info->height;
+      mng_info->mng_width=ping_width;
+      mng_info->mng_height=ping_height;
       mng_info->frame=mng_info->image_box;
       mng_info->clip=mng_info->image_box;
     }
@@ -2019,14 +2126,14 @@ static Image *ReadOnePNGImage(MngInfo *m
       image->page.y=mng_info->y_off[mng_info->object_id];
     }
   image->compression=ZipCompression;
-  image->columns=ping_info->width;
-  image->rows=ping_info->height;
-  if ((ping_info->color_type == PNG_COLOR_TYPE_PALETTE) ||
-      (ping_info->color_type == PNG_COLOR_TYPE_GRAY_ALPHA) ||
-      (ping_info->color_type == PNG_COLOR_TYPE_GRAY))
+  image->columns=ping_width;
+  image->rows=ping_height;
+  if ((ping_colortype == PNG_COLOR_TYPE_PALETTE) ||
+      (ping_colortype == PNG_COLOR_TYPE_GRAY_ALPHA) ||
+      (ping_colortype == PNG_COLOR_TYPE_GRAY))
     {
       image->storage_class=PseudoClass;
-      image->colors=1 << ping_info->bit_depth;
+      image->colors=1U << ping_file_depth;
 #if (QuantumDepth == 8)
       if (image->colors > 256)
         image->colors=256;
@@ -2034,7 +2141,7 @@ static Image *ReadOnePNGImage(MngInfo *m
       if (image->colors > 65536L)
         image->colors=65536L;
 #endif
-      if (ping_info->color_type == PNG_COLOR_TYPE_PALETTE)
+      if (ping_colortype == PNG_COLOR_TYPE_PALETTE)
         {
           int
             number_colors;
@@ -2046,7 +2153,8 @@ static Image *ReadOnePNGImage(MngInfo *m
           image->colors=number_colors;
           if (logging)
             (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                  "    Reading PNG PLTE chunk: number_colors: %d.",number_colors);
+                                  "    Reading PNG PLTE chunk:"
+                                  " number_colors: %d.",number_colors);
         }
     }
 
@@ -2056,8 +2164,8 @@ static Image *ReadOnePNGImage(MngInfo *m
         Initialize image colormap.
       */
       if (!AllocateImageColormap(image,image->colors))
-        ThrowReaderException(ResourceLimitError,MemoryAllocationFailed,image);
-      if (ping_info->color_type == PNG_COLOR_TYPE_PALETTE)
+        png_error(ping, "Could not allocate image colormap");
+      if (ping_colortype == PNG_COLOR_TYPE_PALETTE)
         {
           int
             number_colors;
@@ -2078,7 +2186,7 @@ static Image *ReadOnePNGImage(MngInfo *m
           unsigned long
             scale;
 
-          scale=(MaxRGB/((1 << ping_info->bit_depth)-1));
+          scale=(MaxRGB/((1U << ping_file_depth)-1));
           if (scale < 1)
             scale=1;
           for (i=0; i < (long) image->colors; i++)
@@ -2089,41 +2197,58 @@ static Image *ReadOnePNGImage(MngInfo *m
             }
         }
     }
-  /*
-    Read image scanlines.
-  */
   if (image->delay != 0)
     mng_info->scenes_found++;
-  if (image_info->ping && (image_info->number_scenes != 0) &&
+  if (image_info->ping && ((mng_info->mng_type == 0) ||
+     ((image_info->number_scenes != 0) &&
       mng_info->scenes_found > (long) (image_info->first_scene+
-                                       image_info->number_scenes))
+                                       image_info->number_scenes))))
     {
+      /* This happens later in non-ping decodes */
+      if (png_get_valid(ping,ping_info,PNG_INFO_tRNS))
+        image->storage_class=DirectClass;
+
       if (logging)
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                               "    Skipping PNG image data for scene %ld",
                               mng_info->scenes_found-1);
       png_destroy_read_struct(&ping,&ping_info,&end_info);
+      MagickFreeMemory(mng_info->quantum_scanline);
+      MagickFreeMemory(mng_info->png_pixels);
 #if defined(PNG_SETJMP_NOT_THREAD_SAFE)
       LiberateSemaphoreInfo(&png_semaphore);
 #endif
-      if (image != (Image *) NULL)
-        image->columns=0;
       if (logging)
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                               "  exit ReadOnePNGImage().");
       return (image);
     }
+
+  /*
+    Read image scanlines.
+  */
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                           "    Reading PNG IDAT chunk(s)");
   if (num_passes > 1)
-    png_pixels=MagickAllocateMemory(unsigned char *,
-                                    ping_info->rowbytes*image->rows);
+  {
+    if (ping_rowbytes < GetMagickResourceLimit(MemoryResource)/image->rows)
+      mng_info->png_pixels=MagickAllocateMemory(unsigned char *,
+               ping_rowbytes*image->rows);
+    else
+      png_error(ping, "png_pixels array exceeds MemoryResource");
+  }
   else
-    png_pixels=MagickAllocateMemory(unsigned char *,
-                                    ping_info->rowbytes);
-  if (png_pixels == (unsigned char *) NULL)
-    ThrowReaderException(ResourceLimitError,MemoryAllocationFailed,image);
+  {
+    if ((magick_int64_t)ping_rowbytes < GetMagickResourceLimit(MemoryResource))
+      mng_info->png_pixels=MagickAllocateMemory(unsigned char *, ping_rowbytes);
+    else
+      png_error(ping, "png_rowbytes array exceeds MemoryResource");
+  }
+  if (mng_info->png_pixels == (unsigned char *) NULL)
+  {
+    png_error(ping, "Could not allocate png_pixels array");
+  }
 
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
@@ -2141,22 +2266,28 @@ static Image *ReadOnePNGImage(MngInfo *m
         int
           depth;
 
-        depth=(long) ping_info->bit_depth;
+        depth=(long) ping_bit_depth;
 #endif
-        image->matte=((ping_info->color_type == PNG_COLOR_TYPE_RGB_ALPHA) ||
-                      (ping_info->color_type == PNG_COLOR_TYPE_GRAY_ALPHA) ||
-                      (ping_info->valid & PNG_INFO_tRNS));
+        image->matte=((ping_colortype == PNG_COLOR_TYPE_RGB_ALPHA) ||
+                      (ping_colortype == PNG_COLOR_TYPE_GRAY_ALPHA) ||
+                      (png_get_valid(ping, ping_info, PNG_INFO_tRNS)));
 
         for (y=0; y < (long) image->rows; y++)
           {
             if (num_passes > 1)
-              row_offset=ping_info->rowbytes*y;
+              row_offset=ping_rowbytes*y;
+
             else
               row_offset=0;
-            png_read_row(ping,png_pixels+row_offset,NULL);
-            /* FIXME: Use SetImagePixels? */
-            if (!GetImagePixels(image,0,y,image->columns,1))
+
+            png_read_row(ping,mng_info->png_pixels+row_offset,NULL);
+
+            if (!SetImagePixels(image,0,y,image->columns,1))
               break;
+
+            if (pass < num_passes-1)
+              continue;
+
 #if (QuantumDepth == 8)
             if (depth == 16)
               {
@@ -2164,16 +2295,18 @@ static Image *ReadOnePNGImage(MngInfo *m
                   *p,
                   *r;
 
-                r=png_pixels+row_offset;
+                r=mng_info->png_pixels+row_offset;
                 p=r;
-                if (ping_info->color_type == PNG_COLOR_TYPE_GRAY)
+                if (ping_colortype == PNG_COLOR_TYPE_GRAY)
                   {
                     for (x=(long) image->columns; x > 0; x--)
                       {
                         *r++=*p++;
                         p++;
-                        if ((ping_info->valid & PNG_INFO_tRNS) &&
-                            (((*(p-2) << 8)|*(p-1)) == transparent_color.opacity))
+                        if ((png_get_valid(ping, ping_info, PNG_INFO_tRNS)) &&
+                            ((unsigned long) (((magick_uint32_t) *(p-2) << 8)|
+                                              (magick_uint32_t) *(p-1))
+                            == transparent_color.opacity))
                           {
                             /* Cheap transparency */
                             *r++=TransparentOpacity;
@@ -2182,9 +2315,9 @@ static Image *ReadOnePNGImage(MngInfo *m
                           *r++=OpaqueOpacity;
                       }
                   }
-                else if (ping_info->color_type == PNG_COLOR_TYPE_RGB)
+                else if (ping_colortype == PNG_COLOR_TYPE_RGB)
                   {
-                    if (ping_info->valid & PNG_INFO_tRNS)
+                    if (png_get_valid(ping, ping_info, PNG_INFO_tRNS))
                       for (x=(long) image->columns; x > 0; x--)
                         {
                           *r++=*p++;
@@ -2193,9 +2326,12 @@ static Image *ReadOnePNGImage(MngInfo *m
                           p++;
                           *r++=*p++;
                           p++;
-                          if ((((*(p-6) << 8)|*(p-5)) == transparent_color.red) &&
-                              (((*(p-4) << 8)|*(p-3)) == transparent_color.green) &&
-                              (((*(p-2) << 8)|*(p-1)) == transparent_color.blue))
+                          if (((unsigned long) (((magick_uint32_t) *(p-6) << 8)|*(p-5)) ==
+                              transparent_color.red) &&
+                              ((unsigned long) (((magick_uint32_t) *(p-4) << 8)|*(p-3)) ==
+                              transparent_color.green) &&
+                              ((unsigned long) (((magick_uint32_t) *(p-2) << 8)|*(p-1)) ==
+                              transparent_color.blue))
                             {
                               /* Cheap transparency */
                               *r++=TransparentOpacity;
@@ -2215,231 +2351,239 @@ static Image *ReadOnePNGImage(MngInfo *m
                           *r++=OpaqueOpacity;
                         }
                   }
-                else if (ping_info->color_type == PNG_COLOR_TYPE_RGB_ALPHA)
+                else if (ping_colortype == PNG_COLOR_TYPE_RGB_ALPHA)
                   for (x=(long) (4*image->columns); x > 0; x--)
                     {
                       *r++=*p++;
                       p++;
                     }
-                else if (ping_info->color_type == PNG_COLOR_TYPE_GRAY_ALPHA)
+                else if (ping_colortype == PNG_COLOR_TYPE_GRAY_ALPHA)
                   for (x=(long) (2*image->columns); x > 0; x--)
                     {
                       *r++=*p++;
                       p++;
                     }
               }
-            if (depth == 8 && ping_info->color_type == PNG_COLOR_TYPE_GRAY)
+            if (depth == 8 && ping_colortype == PNG_COLOR_TYPE_GRAY)
               (void) ImportImagePixelArea(image,(QuantumType) GrayQuantum,
-                                          image->depth,png_pixels+row_offset,0,0);
-            if (ping_info->color_type == PNG_COLOR_TYPE_GRAY ||
-                ping_info->color_type == PNG_COLOR_TYPE_GRAY_ALPHA)
+                                          image->depth,mng_info->png_pixels+
+                                          row_offset,0,0);
+            else if (ping_colortype == PNG_COLOR_TYPE_GRAY)
               {
                 image->depth=8;
-                (void) ImportImagePixelArea(image,(QuantumType) GrayAlphaQuantum,
-                                            image->depth,png_pixels+row_offset,0,0);
+                (void) ImportImagePixelArea(image,
+                                           (QuantumType) GrayQuantum,
+                                            image->depth,mng_info->png_pixels+
+                                            row_offset,0,0);
                 image->depth=depth;
               }
-            else if (depth == 8 && ping_info->color_type == PNG_COLOR_TYPE_RGB)
+            else if (ping_colortype == PNG_COLOR_TYPE_GRAY_ALPHA)
+              {
+                image->depth=8;
+                (void) ImportImagePixelArea(image,
+                                           (QuantumType) GrayAlphaQuantum,
+                                            image->depth,mng_info->png_pixels+
+                                            row_offset,0,0);
+                image->depth=depth;
+              }
+            else if (depth == 8 && ping_colortype == PNG_COLOR_TYPE_RGB)
               (void) ImportImagePixelArea(image,(QuantumType) RGBQuantum,
-                                          image->depth,png_pixels+row_offset,0,0);
-            else if (ping_info->color_type == PNG_COLOR_TYPE_RGB ||
-                     ping_info->color_type == PNG_COLOR_TYPE_RGB_ALPHA)
+                                          image->depth,mng_info->png_pixels+
+                                          row_offset,0,0);
+            else if (ping_colortype == PNG_COLOR_TYPE_RGB)
+              {
+                image->depth=8;
+                (void) ImportImagePixelArea(image,(QuantumType) RGBQuantum,
+                                            image->depth,mng_info->png_pixels+
+                                            row_offset,0,0);
+                image->depth=depth;
+              }
+            else if (ping_colortype == PNG_COLOR_TYPE_RGB_ALPHA)
               {
                 image->depth=8;
                 (void) ImportImagePixelArea(image,(QuantumType) RGBAQuantum,
-                                            image->depth,png_pixels+row_offset,0,0);
+                                            image->depth,mng_info->png_pixels+
+                                            row_offset,0,0);
                 image->depth=depth;
               }
-            else if (ping_info->color_type == PNG_COLOR_TYPE_PALETTE)
+            else if (ping_colortype == PNG_COLOR_TYPE_PALETTE)
               (void) ImportImagePixelArea(image,(QuantumType) IndexQuantum,
-                                          ping_info->bit_depth,png_pixels+row_offset,0,0); /* FIXME, sample size ??? */
+                                          ping_bit_depth,mng_info->png_pixels+
+                                          row_offset,0,0);
+                                          /* FIXME, sample size ??? */
 #else /* (QuantumDepth != 8) */
 
-            if (ping_info->color_type == PNG_COLOR_TYPE_GRAY)
+            if (ping_colortype == PNG_COLOR_TYPE_GRAY)
               (void) ImportImagePixelArea(image,(QuantumType) GrayQuantum,
-                                          image->depth,png_pixels+row_offset,0,0);
-            else if (ping_info->color_type == PNG_COLOR_TYPE_GRAY_ALPHA)
+                                          image->depth,mng_info->png_pixels+
+                                          row_offset,0,0);
+            else if (ping_colortype == PNG_COLOR_TYPE_GRAY_ALPHA)
               (void) ImportImagePixelArea(image,(QuantumType) GrayAlphaQuantum,
-                                          image->depth,png_pixels+row_offset,0,0);
-            else if (ping_info->color_type == PNG_COLOR_TYPE_RGB_ALPHA)
+                                          image->depth,mng_info->png_pixels+
+                                          row_offset,0,0);
+            else if (ping_colortype == PNG_COLOR_TYPE_RGB_ALPHA)
               (void) ImportImagePixelArea(image,(QuantumType) RGBAQuantum,
-                                          image->depth,png_pixels+row_offset,0,0);
-            else if (ping_info->color_type == PNG_COLOR_TYPE_PALETTE)
+                                          image->depth,mng_info->png_pixels+
+                                          row_offset,0,0);
+            else if (ping_colortype == PNG_COLOR_TYPE_PALETTE)
               (void) ImportImagePixelArea(image,(QuantumType) IndexQuantum,
-                                          ping_info->bit_depth,png_pixels+row_offset,0,0); /* FIXME, sample size ??? */
+                                          ping_bit_depth,mng_info->png_pixels+
+                                          row_offset,0,0);
+                                          /* FIXME, sample size ??? */
             else
               (void) ImportImagePixelArea(image,(QuantumType) RGBQuantum,
-                                          image->depth,png_pixels+row_offset,0,0);
+                                          image->depth,mng_info->png_pixels+
+                                          row_offset,0,0);
 #endif
             if (!SyncImagePixels(image))
               break;
           }
+
         if (image->previous == (Image *) NULL)
           if (!MagickMonitor(LoadImageTag,pass,num_passes,exception))
             break;
       }
+
   else /* image->storage_class != DirectClass */
-    for (pass=0; pass < num_passes; pass++)
-      {
-        Quantum
-          *quantum_scanline;
+    {
+      image->matte=ping_colortype == PNG_COLOR_TYPE_GRAY_ALPHA;
+      mng_info->quantum_scanline=
+        MagickAllocateMemory(Quantum *,
+                             (image->matte ?  2 : 1) *
+                             image->columns*sizeof(Quantum));
+      if (mng_info->quantum_scanline == (Quantum *) NULL)
+        png_error(ping, "Could not allocate quantum_scanline");
+      (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                            "      Allocated quantum_scanline");
 
-        register Quantum
-          *r;
+      for (pass=0; pass < num_passes; pass++)
+        {
+          register Quantum
+            *r;
 
-        /*
-          Convert grayscale image to PseudoClass pixel packets.
-        */
-        image->matte=ping_info->color_type == PNG_COLOR_TYPE_GRAY_ALPHA;
-        quantum_scanline=MagickAllocateMemory(Quantum *,(image->matte ?  2 : 1) *
-                                              image->columns*sizeof(Quantum));
-        if (quantum_scanline == (Quantum *) NULL)
-          ThrowReaderException(ResourceLimitError,MemoryAllocationFailed,image);
-        for (y=0; y < (long) image->rows; y++)
-          {
-            if (num_passes > 1)
-              row_offset=ping_info->rowbytes*y;
-            else
-              row_offset=0;
-            png_read_row(ping,png_pixels+row_offset,NULL);
-            q=SetImagePixels(image,0,y,image->columns,1);
-            if (q == (PixelPacket *) NULL)
-              break;
-            indexes=GetIndexes(image);
-            p=png_pixels+row_offset;
-            r=quantum_scanline;
-            switch (ping_info->bit_depth)
-              {
-              case 1:
-                {
-                  register long
-                    bit;
+          /*
+            Convert grayscale image to PseudoClass pixel packets.
+          */
+          for (y=0; y < (long) image->rows; y++)
+            {
+              register unsigned char
+                *p;
 
-                  for (x=(long) image->columns-7; x > 0; x-=8)
-                    {
-                      for (bit=7; bit >= 0; bit--)
-                        *r++=((*p) & (0x01 << bit) ? 0x01 : 0x00);
-                      p++;
-                    }
-                  if ((image->columns % 8) != 0)
-                    {
-                      for (bit=7; bit >= (long) (8-(image->columns % 8)); bit--)
-                        *r++=((*p) & (0x01 << bit) ? 0x01 : 0x00);
-                    }
-                  break;
-                }
-              case 2:
-                {
-                  for (x=(long) image->columns-3; x > 0; x-=4)
-                    {
-                      *r++=(*p >> 6) & 0x03;
-                      *r++=(*p >> 4) & 0x03;
-                      *r++=(*p >> 2) & 0x03;
-                      *r++=(*p++) & 0x03;
-                    }
-                  if ((image->columns % 4) != 0)
-                    {
-                      for (i=3; i >= (long) (4-(image->columns % 4)); i--)
-                        *r++=(*p >> (i*2)) & 0x03;
-                    }
-                  break;
-                }
-              case 4:
-                {
-                  for (x=(long) image->columns-1; x > 0; x-=2)
-                    {
-                      *r++=(*p >> 4) & 0x0f;
-                      *r++=(*p++) & 0x0f;
-                    }
-                  if ((image->columns % 2) != 0)
-                    *r++=(*p++ >> 4) & 0x0f;
-                  break;
-                }
-              case 8:
-                {
-                  if (ping_info->color_type == 4)
-                    for (x=(long) image->columns; x > 0; x--)
-                      {
-                        *r++=*p++;
-                        /* In image.h, OpaqueOpacity is 0
-                         * TransparentOpacity is MaxRGB
-                         * In a PNG datastream, Opaque is MaxRGB
-                         * and Transparent is 0.
-                         */
-                        q->opacity=ScaleCharToQuantum(255-(*p++));
-                        q++;
-                      }
-                  else
-                    for (x=(long) image->columns; x > 0; x--)
-                      *r++=*p++;
-                  break;
-                }
-              case 16:
+              if (num_passes > 1)
+                row_offset=ping_rowbytes*y;
+
+              else
+                row_offset=0;
+
+              png_read_row(ping,mng_info->png_pixels+row_offset,NULL);
+              q=SetImagePixels(image,0,y,image->columns,1);
+              if (q == (PixelPacket *) NULL)
+                break;
+
+              if (pass < num_passes-1)
+                continue;
+
+              indexes=GetIndexes(image);
+              p=mng_info->png_pixels+row_offset;
+              r=mng_info->quantum_scanline;
+              switch (ping_bit_depth)
                 {
-                  for (x=(long) image->columns; x > 0; x--)
-                    {
-#if (QuantumDepth == 16)
-                      if (image->colors > 256)
-                        *r=((*p++) << 8);
-                      else
-                        *r=0;
-                      *r|=(*p++);
-                      r++;
-                      if (ping_info->color_type == 4)
+                case 8:
+                  {
+                    if (ping_colortype == 4)
+                      for (x=(long) image->columns; x > 0; x--)
                         {
-                          q->opacity=((*p++) << 8);
-                          q->opacity|=(*p++);
-                          q->opacity=(Quantum) (MaxRGB-q->opacity);
+                          *r++=*p++;
+                          /* In image.h, OpaqueOpacity is 0
+                           * TransparentOpacity is MaxRGB
+                           * In a PNG datastream, Opaque is MaxRGB
+                           * and Transparent is 0.
+                           */
+                          q->opacity=ScaleCharToQuantum(255-(*p++));
                           q++;
                         }
+                    else
+                      for (x=(long) image->columns; x > 0; x--)
+                        *r++=*p++;
+                    break;
+                  }
+                case 16:
+                  {
+                    for (x=(long) image->columns; x > 0; x--)
+                      {
+#if (QuantumDepth == 16)
+                        if (image->colors > 256)
+                          *r=(((magick_uint32_t) *p++) << 8);
+                        else
+                          *r=0;
+                        *r|=(*p++);
+                        r++;
+                        if (ping_colortype == 4)
+                          {
+                            q->opacity=(((magick_uint32_t) *p++) << 8);
+                            q->opacity|=((magick_uint32_t) *p++);
+                            q->opacity=(Quantum) (MaxRGB-q->opacity);
+                            q++;
+                          }
 #else
 #if (QuantumDepth == 32)
-                      if (image->colors > 256)
-                        *r=((*p++) << 8);
-                      else
-                        *r=0;
-                      *r|=(*p++);
-                      r++;
-                      if (ping_info->color_type == 4)
-                        {
-                          q->opacity=((*p++) << 8);
-                          q->opacity|=(*p++);
-                          q->opacity*=65537L;
-                          q->opacity=(Quantum) (MaxRGB-q->opacity);
-                          q++;
-                        }
+                        if (image->colors > 256)
+                          *r=(((magick_uint32_t) *p++) << 8);
+                        else
+                          *r=0;
+                        *r|=(*p++);
+                        r++;
+                        if (ping_colortype == 4)
+                          {
+                            q->opacity=(((magick_uint32_t) *p++) << 8);
+                            q->opacity|=((magick_uint32_t) *p++);
+                            q->opacity*=65537U;
+                            q->opacity=(Quantum) (MaxRGB-q->opacity);
+                            q++;
+                          }
 #else /* QuantumDepth == 8 */
-                      *r++=(*p++);
-                      p++; /* strip low byte */
-                      if (ping_info->color_type == 4)
-                        {
-                          q->opacity=(Quantum) (MaxRGB-(*p++));
-                          p++;
-                          q++;
-                        }
+                        *r++=(*p++);
+                        p++; /* strip low byte */
+                        if (ping_colortype == 4)
+                          {
+                            q->opacity=(Quantum) (MaxRGB-(*p++));
+                            p++;
+                            q++;
+                          }
 #endif
 #endif
-                    }
+                      }
+                    break;
+                  }
+                default:
                   break;
                 }
-              default:
+              /*
+                Transfer image scanline.
+              */
+              r=mng_info->quantum_scanline;
+
+              for (x=0; x < (long) image->columns; x++)
+                indexes[x]=(*r++);
+
+              if (!SyncImagePixels(image))
                 break;
-              }
-            /*
-              Transfer image scanline.
-            */
-            r=quantum_scanline;
-            for (x=0; x < (long) image->columns; x++)
-              indexes[x]=(*r++);
-            if (!SyncImagePixels(image))
-              break;
-          }
-        if (image->previous == (Image *) NULL)
-          if (!MagickMonitor(LoadImageTag,pass,num_passes,exception))
+            }
+
+          /* Quit 'passes' loop if we encountered an error */
+          if (y < (long) image->rows)
             break;
-        MagickFreeMemory(quantum_scanline);
+
+          if (image->previous == (Image *) NULL)
+            if (!MagickMonitor(LoadImageTag,pass,num_passes,exception))
+              break;
       }
 
+      MagickFreeMemory(mng_info->quantum_scanline);
+      (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                            "      Free'ed quantum_scanline after last pass");
+    }
+
   if (image->storage_class == PseudoClass)
     (void) SyncImage(image);
   png_read_end(ping,ping_info);
@@ -2448,18 +2592,19 @@ static Image *ReadOnePNGImage(MngInfo *m
       (long) image_info->first_scene && image->delay != 0.)
     {
       png_destroy_read_struct(&ping,&ping_info,&end_info);
-      MagickFreeMemory(png_pixels);
+      MagickFreeMemory(mng_info->quantum_scanline);
+      MagickFreeMemory(mng_info->png_pixels);
       image->colors=2;
       (void) SetImage(image,TransparentOpacity);
 #if defined(PNG_SETJMP_NOT_THREAD_SAFE)
-      LiberateSemaphoreInfo(&png_semaphore);
+       LiberateSemaphoreInfo(&png_semaphore);
 #endif
       if (logging)
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                               "  exit ReadOnePNGImage().");
       return (image);
     }
-  if (ping_info->valid & PNG_INFO_tRNS)
+  if (png_get_valid(ping, ping_info, PNG_INFO_tRNS))
     {
       ClassType
         storage_class;
